config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  # Main page (list of all companies)
  root 'companies#index'

  # Companies
  resources :companies
  put '/companies/:id/:action', to: 'companies#upvote', as: 'companies_upvote'
  put '/companies/:id/:action', to: 'companies#downvote', as: 'companies_downvote'

  # Employees (users)
  put '/users/:id/:action', to: 'users#upvote', as: 'users_upvote'
  put '/users/:id/:action', to: 'users#downvote', as: 'users_downvote'

  # Favorites
  get '/favorites', to: 'favorites#index', as: :favorites

end

app/models/company.rb
# == Schema Information
#
# Table name: companies
#
#  id           :integer          not null, primary key
#  name         :string
#  image        :string
#  country_code :string
#  created_at   :datetime         not null
#  updated_at   :datetime         not null
#

class Company < ActiveRecord::Base
  # Each company has many employees
  has_many :users

  # Validations
  validates :name, :country_code, presence: true
  validates :name, length: { minimum: 3 }

  # Likes system part
  acts_as_votable

  # Likes by current_user
  def self.likes(user)
    likes = []

    user.votes.where(votable_type: 'Company').each do |vote|
      likes << find(vote.votable_id)
    end

    likes
  end
end

app/controllers/companies_controller.rb
# == Schema Information
#
# Table name: companies
#
#  id           :integer          not null, primary key
#  name         :string
#  image        :string
#  country_code :string
#  created_at   :datetime         not null
#  updated_at   :datetime         not null
#

class CompaniesController < ApplicationController
  before_action :authenticate_user!

  # Main page. List of all companies
  def index
    @companies = Company.all
  end

  # Company with its employees
  def show
    @company = Company.find(params[:id])
    @employees = @company.users
  end

  # Company create process
  def create
    company = Company.create(company_params)
    if company.save
      flash[:success] = 'Success'
      redirect_to root_path
    else
      flash[:error] = post.errors.to_a.join('. ')
      redirect_to :back
    end
  end

  # Like company bu current_user
  def upvote
    @company = Company.find(params[:id])
    respond_to do |format|
      @company.liked_by current_user
      @company.save
      format.html { redirect_to :back }
      # format.json { render json: { count: @company.votes_for.size } }
      format.js { render layout: false }
    end
  end

  # UnLike company bu current_user
  def downvote
    @company = Company.find(params[:id])
    respond_to do |format|
      @company.unliked_by current_user
      @company.save
      format.html { redirect_to :back }
      # format.json { render json: { count: @company.votes_for.size } }
      format.js { render layout: false }
    end
  end

  private

  def company_params
    params.require(:company).permit(:name, :country_code)
  end
end

app/helpers/companies_helper.rb
# == Schema Information
#
# Table name: companies
#
#  id           :integer          not null, primary key
#  name         :string
#  image        :string
#  country_code :string
#  created_at   :datetime         not null
#  updated_at   :datetime         not null
#

module CompaniesHelper
end

app/views/companies/_like.slim
div.text-center
  span style="font-size: 22px;"
    = link_to companies_upvote_path(company), { method: :put, remote: true, class: "btn-w-img fav-btn item_vote"}
      <i class="ti-heart icon" style="color: white;"></i>

app/views/companies/_unlike.slim
div.text-center
  span style="font-size: 22px;"
    = link_to companies_downvote_path(company), { method: :put, remote: true, class: "main-btn btn-w-img fav-btn item_vote active"}
      <i class="ti-heart icon" style="color: rgba(255, 0, 0, 0.69)"></i>

app/views/companies/downvote.js.erb
$('.item_vote').on('ajax:send', function() {
  $(this).addClass('loading');
}).on('ajax:complete', function() {
}).on('ajax:error', function() {
  $(this).after('<div class="error">There was an issue.</div>');
}).on('ajax:success', function(data) {
  $(this).removeClass('spinner spinner-blink');
  $(this).replaceWith("<%= j render partial: 'companies/like', locals: {:company => @company } %>");
});

app/views/companies/index.slim
== content_for(:page_title, 'Companies list')

/ Promo title
section.page-title.page-title-4.bg-secondary
  div.container
    div.row
      div.col-md-6
        h3.uppercase.mb0
          <i class="ti-layers"></i> Companies list

/ Companies
- @companies.each do |company|
  section.image-bg.bg-dark.parallax.overlay.pt160.pb160.pt-xs-40.pb-xs-40
    div.background-image-holder.fadeIn style="transform: translate3d(0px, 137px, 0px); background: url('#{company.image}');"
      img.background-image alt="Background Image" src="#{company.image}" style="display: none;"
    div.container
      div.row.back
        div.col-sm-12.text-center
          h2.uppercase.mb8
            = company.name
          p.lead.mb40
            = "From " + ISO3166::Country.new(company.country_code).name
          p.lead.mb40
            = company.users.count.to_s + " employees"
          - unless current_user.voted_on? company
            = render :partial => "companies/like", :locals => {:company => company}
          - else
            = render :partial => "companies/unlike", :locals => {:company => company}
          br
          br
          = link_to 'Explore Team', company_path(company.id), class: 'btn btn-lg btn-white mb0'
          br
          br

app/views/companies/new.slim
== content_for(:page_title, 'New company')

section.cover.fullscreen.image-bg.overlay style="height: 784px;"
  div.background-image-holder.fadeIn style="background: url('/back.jpg');"
    img.background-image alt="image" src="/back.jpg" style="display: none;"
  div.container.v-align-transform
    div.row
      div.col-md-4.col-md-offset-4.col-sm-8.col-sm-offset-2
        div.feature.bordered.text-center.back
          h4.uppercase
            | New company
          = simple_form_for :company, url: {action: "create"} do |f|
            = f.input_field :name, required: true, autofocus: true, class: 'mb0', placeholder: 'Company name'
            = f.country_select :country_code, nil, :required => true 
            = f.button :submit, "Create"

app/views/companies/show.slim
== content_for(:page_title, @company.name)

section.page-title.page-title-1.image-bg.overlay.parallax
  div.background-image-holder.fadeIn style="transform: translate3d(0px, 0px, 0px); top: -100px; background: url(#{@company.image});"
    img.background-image alt="Background Image" src="#{@company.image}" style="display: none;"
  div.container
    div.row
      div.col-sm-12.text-center
        h2.uppercase.mb0
          = @company.name
  ol.breadcrumb.breadcrumb-2
    li
      = "From " + ISO3166::Country.new(@company.country_code).name

hr.mb0

/ Employees
section
  div.container
    div.row
      / Each
      - @employees.each do |user, index|
        div.col-md-9.col-md-offset-1.col-sm-12.mb40.mb-xs-24.p0
          div.col-sm-7.mb64.mb-xs-24
            img alt="Pic" src="#{user.avatar}"
          div.col-sm-5.mb64.mb-xs-24
            h5.uppercase.mb0
              = user.first_name + " " + user.last_name
            span.inline-block.mb40.mb-xs-24
              = user.profession
            p
              = Faker::Lorem.paragraph

            - unless current_user.voted_on? user
              = render :partial => "users/like", :locals => {:user => user}
            - else
              = render :partial => "users/unlike", :locals => {:user => user}

app/views/companies/upvote.js.erb
$('.item_vote').bind('ajax:send', function() {
  $(this).addClass('loading');
}).on('ajax:complete', function() {
}).on('ajax:error', function() {
  $(this).after('<div class="error">There was an issue.</div>');
}).on('ajax:success', function(data) {
  $(this).replaceWith("<%= j render partial: 'companies/unlike', locals: {:company => @company } %>");
});